package arm;

class MyTrait extends iron.Trait {
	public function new() {
		super();

		notifyOnInit(function() {
			// Retrieve camera object
			var cam = cast(iron.Scene.active.getChild("Camera.001"), iron.object.CameraObject);

			// Create render target for camera
			cam.renderTarget = kha.Image.createRenderTarget(
				640,
				360,
				kha.graphics4.TextureFormat.RGBA32,
				kha.graphics4.DepthStencilFormat.NoDepthAndStencil
			);

			notifyOnRender2D(function(g:kha.graphics2.Graphics) {

				var image = cam.renderTarget;
				
				g.color = 0xffffffff;
				g.drawScaledImage(image, 40, 40 + image.height / 1, image.width / 1, -image.height / 1);

			});


			notifyOnRender(function(g:kha.graphics4.Graphics) {
				// Set as scene camera
				var activeCamera = iron.Scene.active.camera;
				iron.Scene.active.camera = cam;

				// Update camera output
				cam.renderFrame(g);
				
				// Restore original camera
				iron.Scene.active.camera = activeCamera;
			});
		});
	}
}
